package kr.nipa.smartui.phone.framework.base;

import java.util.Calendar;

import kr.nipa.smartui.phone.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;

public class ActivityBase extends Activity {		
	private final int _OKDIALOG_ID = 11;
	private final int _OKCANCELDIALOG_ID = 12;
//	private final int _OKDIALOG_OPTION_ID = 21;
//	private final int _OKDIALOG_CHECK_ID = 31;	
	private final int _OKDIALOG_DATE_ID = 51;
	private final int _OKDIALOG_PASSWORD_ID = 61;
	private final int _OKCANCELDIALOG_PASSWORD_ID = 62;
	
	private DialogInterface.OnClickListener _DialogButtonClickListener = null;
	private DatePickerDialog.OnDateSetListener _DateDialogDateSetListener = null;
	private DialogInterface.OnClickListener _PasswordDialogButtonClickListener = null;
//	private DialogInterface.OnClickListener _OptionDialogButtonClickListener = null;
//	private DialogInterface.OnClickListener _OptionDialogItemClickListener = null;
	
	private EditText _EditTextOkDialogPassword = null;
	
	private EditText _EditTextOkCancelDialogPassword1 = null;
	private EditText _EditTextOkCancelDialogPassword2 = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }
	
	@Override
	public void onPause() {
    	super.onPause();
    }
	
	@Override
	public void onResume() {
		super.onResume();
	}
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	@Override
	protected Dialog onCreateDialog(int id, Bundle args) {
		super.onCreateDialog(id);
		
		AlertDialog dialog = null;
		
//		LayoutInflater layoutInflaterTitle = (LayoutInflater)getSystemService(LAYOUT_INFLATER_SERVICE);	
//		View viewTitle = layoutInflaterTitle.inflate(R.layout.cough_dialog_title_bar, null);	
		
		LayoutInflater layoutInflater = null;		
		View view = null;
		
		switch (id) {
		case _OKDIALOG_ID:			
			dialog = new AlertDialog.Builder(this)
//					 .setCustomTitle(viewTitle)
					 .setTitle(args.getCharSequence("arg1"))
					 .setMessage(args.getCharSequence("arg2"))
			         .setPositiveButton(android.R.string.ok, _DialogButtonClickListener)
			         .create();		       
			
			break;
		case _OKCANCELDIALOG_ID:
			dialog = new AlertDialog.Builder(this)
					 .setTitle(args.getCharSequence("arg1"))
					 .setMessage(args.getCharSequence("arg2"))
			         .setPositiveButton(android.R.string.ok, _DialogButtonClickListener)
			         .setNegativeButton(android.R.string.cancel, _DialogButtonClickListener)
			         .create();		       
			
			break;
		case _OKDIALOG_DATE_ID:
			int year = args.getInt("arg2");
			int month = args.getInt("arg3");
			int day = args.getInt("arg4");
			
			dialog = new DatePickerDialog(this, _DateDialogDateSetListener, year, month, day);
			
			break;
		case _OKDIALOG_PASSWORD_ID:
			layoutInflater = (LayoutInflater)getSystemService(LAYOUT_INFLATER_SERVICE);
			view = layoutInflater.inflate(R.layout.common_okdialog_password, null);	
			
			_EditTextOkDialogPassword = (EditText)view.findViewById(R.id.editTextCommonOkDialogPassword);  
			
			dialog = new AlertDialog.Builder(this)
//					 .setCustomTitle(viewTitle)
					 .setView(view)
					 .setTitle(args.getCharSequence("arg1"))
			         .setPositiveButton(android.R.string.ok, _PasswordDialogButtonClickListener)
			         .create();		       
			
			break;
		case _OKCANCELDIALOG_PASSWORD_ID:
			layoutInflater = (LayoutInflater)getSystemService(LAYOUT_INFLATER_SERVICE);
			view = layoutInflater.inflate(R.layout.common_okcanceldialog_password, null);	
			
			_EditTextOkCancelDialogPassword1 = (EditText)view.findViewById(R.id.editTextCommonOkCancelDialogPassword1);
			_EditTextOkCancelDialogPassword2 = (EditText)view.findViewById(R.id.editTextCommonOkCancelDialogPassword2);	
			
			dialog = new AlertDialog.Builder(this)
//					 .setCustomTitle(viewTitle)
					 .setView(view)
					 .setTitle(args.getCharSequence("arg1"))
			         .setPositiveButton(android.R.string.ok, _PasswordDialogButtonClickListener)
			         .setNegativeButton(android.R.string.cancel, _PasswordDialogButtonClickListener)
			         .create();		       
			
			break;
//		case _ID_OKDIALOG_ID_OPTION:			
//			dialog = new AlertDialog.Builder(this)
//					 .setTitle(args.getCharSequence("arg1"))
//			         .setSingleChoiceItems(args.getCharSequenceArray("arg2"), args.getInt("arg3"), _OptionDialogItemClickListener)
//			         .setPositiveButton(android.R.string.ok, _OptionDialogButtonClickListener)
//			         .create();
//			
//			break;
		}
		
		return dialog;
	}
	
	@Override
	protected void onPrepareDialog(int id, Dialog dialog, Bundle args) {
		super.onPrepareDialog(id, dialog);
		
//		LayoutInflater inflater = null;
//		View view = null;
		
		switch (id) {
		case _OKDIALOG_ID:
//			((AlertDialog)dialog).setTitle(args.getCharSequence("arg1"));
			((AlertDialog)dialog).setMessage(args.getCharSequence("arg2"));
			
			break;
		case _OKCANCELDIALOG_ID:
//			((AlertDialog)dialog).setTitle(args.getCharSequence("arg1"));
			((AlertDialog)dialog).setMessage(args.getCharSequence("arg2"));
			
			break;
		case _OKDIALOG_PASSWORD_ID:			
			_EditTextOkDialogPassword.setText("");
			
			break;
		case _OKCANCELDIALOG_PASSWORD_ID:			
			_EditTextOkCancelDialogPassword1.setText("");
			_EditTextOkCancelDialogPassword2.setText("");
			
			break;
		}
	}
	
/* region 메서드이다. *****************************************************************************************************/
	
	protected void showOkDialogDate(String title, DatePickerDialog.OnDateSetListener dateDialogDateSetListener) {
		Calendar cal = Calendar.getInstance();
		int year = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH);
		int day = cal.get(Calendar.DAY_OF_MONTH);
		
		showOkDialogDate(title, year, month, day, dateDialogDateSetListener);
	}
	
	protected void showOkDialogDate(String title, int year, int month, int day, DatePickerDialog.OnDateSetListener dateDialogDateSetListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		args.putInt("arg2", year);
		args.putInt("arg3", month);
		args.putInt("arg4", day);
		
		_DateDialogDateSetListener = dateDialogDateSetListener;
		
		showDialog(_OKDIALOG_DATE_ID, args);
	}
	
	protected void showOkDialogPassword(String title, DialogInterface.OnClickListener passwordDialogButtonClickListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		
		_PasswordDialogButtonClickListener = passwordDialogButtonClickListener;
		
		showDialog(_OKDIALOG_PASSWORD_ID, args);
	}
	
	protected void showOkCancelDialogPassword(String title, DialogInterface.OnClickListener passwordDialogButtonClickListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		
		_PasswordDialogButtonClickListener = passwordDialogButtonClickListener;
		
		showDialog(_OKCANCELDIALOG_PASSWORD_ID, args);
	}
	
	protected void showOkDialogError(Exception ex) {
		showOkDialogError(getString(R.string.shortmessage_Error), ex, null);
	}
	
	protected void showOkDialogError(Exception ex, DialogInterface.OnClickListener dialogButtonClickListener) {
		showOkDialogError(getString(R.string.shortmessage_Error), ex, dialogButtonClickListener);
	}
	
	protected void showOkDialogError(String title, Exception ex, DialogInterface.OnClickListener dialogButtonClickListener) {
		String message = ex.getStackTrace().toString() + "\n" + ex.getMessage().toString();
		
		showOkDialog(title, message, dialogButtonClickListener);
	}
	
	protected void showOkDialog(String title, String message, DialogInterface.OnClickListener dialogButtonClickListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		args.putString("arg2", message);
		
		_DialogButtonClickListener = dialogButtonClickListener;
		
		showDialog(_OKDIALOG_ID, args);
	}
	
	protected void showOkCancelDialog(String title, String message, DialogInterface.OnClickListener dialogButtonClickListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		args.putString("arg2", message);
		
		_DialogButtonClickListener = dialogButtonClickListener;
		
		showDialog(_OKCANCELDIALOG_ID, args);
	}
	
//	protected void showOptionDialogOk(String title, CharSequence[] items, int checkedItemIndex, DialogInterface.OnClickListener optionDialogItemClickListener, DialogInterface.OnClickListener optionDialogButtonClickListener) {
//		Bundle args = new Bundle();
//		args.putString("arg1", title);
//		args.putCharSequenceArray("arg2", items);
//		args.putInt("arg3", checkedItemIndex);
//		
//		_OptionDialogItemClickListener = optionDialogItemClickListener;
//		_OptionDialogButtonClickListener = optionDialogButtonClickListener;
//		
//		showDialog(_ID_OKDIALOG_ID_OPTION, args);
//	}
}