package kr.nipa.smartui.phone.framework.base.cough;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.ActivityBase;
import kr.nipa.smartui.phone.ui.cough.patient.copa0100a;
import kr.nipa.smartui.phone.ui.cough.preference.copr0000a;
import kr.nipa.smartui.phone.framework.util.PreferenceUtil;
import kr.nipa.smartui.phone.ui.Application;
import kr.nipa.smartui.phone.ui.Main;
import kr.nipa.smartui.phone.ui.cough.message.coms0100a;
import kr.nipa.smartui.phone.ui.cough.message.coms0200a;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.SubMenu;
import android.widget.TextView;

public class CoughActivityBase extends ActivityBase {	
	private TextView _TextViewCoughTitleStatusBarPatientInfo = null;
	
	private Application _Application = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // 제목(상태) 바이다.
        _TextViewCoughTitleStatusBarPatientInfo = (TextView)findViewById(R.id.textViewCoughTitleStatusBarPatientInfo);
        
        _Application = (Application)getApplication();
    }
	
	@Override
	protected void onDestroy() {		
		super.onDestroy();
	}
	
	@Override
	public void onPause() {
    	super.onPause();
    }
	
	@Override
	public void onResume() {
		super.onResume();
		
		// 제목(상태) 바에 환자의 기본정보를 설정한다.
		setTitleStatusBarPatientInfo();
	}
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuItem itemHome = menu.add(0, R.string.cough_optionmenu_item_id_home, 0, getString(R.string.cough_optionmenu_item_text_home));
		itemHome.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_home));
		
		MenuItem itemSend = menu.add(0, R.string.cough_optionmenu_item_id_sendmessage, 0, getString(R.string.cough_optionmenu_item_text_sendmessage));
		itemSend.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_sendmessage));
		
		MenuItem itemReceived = menu.add(0, R.string.cough_optionmenu_item_id_receivedmessage, 0, getString(R.string.cough_optionmenu_item_text_receivedmessage));
		itemReceived.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_receivedmessage));
		
		MenuItem itemPatient = menu.add(0, R.string.cough_optionmenu_item_id_patient, 0, getString(R.string.cough_optionmenu_item_text_patient));
		itemPatient.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_doctor));
		
		SubMenu itemMore = menu.addSubMenu(0, R.string.cough_optionmenu_item_id_more, 0, getString(R.string.cough_optionmenu_item_text_more));
		itemMore.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_more));
		
		MenuItem itemPreference = itemMore.add(0, R.string.cough_optionmenu_item_id_preferences, 0, getString(R.string.cough_optionmenu_item_text_preferences));
//		itemPreference.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_more));
		
		MenuItem itemHelp = itemMore.add(0, R.string.cough_optionmenu_item_id_help, 0, getString(R.string.cough_optionmenu_item_text_help));
//		itemHelp.setIcon(getResources().getDrawable(R.drawable.cough_optionmenu_icon_more));
		
		return super.onCreateOptionsMenu(menu);
	}
	
	@Override
    public boolean onPrepareOptionsMenu(Menu menu) {
		MenuItem itemPatient = menu.findItem(R.string.cough_optionmenu_item_id_patient);
		if (getPatientNo() != 0) itemPatient.setTitle(getPatientName());
		else itemPatient.setTitle(getString(R.string.shortmessage_Select));
		
		return super.onPrepareOptionsMenu(menu);
    }
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item)	{
		Intent intent = null;
		
		switch(item.getItemId()) {
		case R.string.cough_optionmenu_item_id_home:
			// "메인" 화면으로 이동한다.
			intent = new Intent(CoughActivityBase.this, Main.class);
			startActivity(intent);
			
			break;
		case R.string.cough_optionmenu_item_id_sendmessage:
			// "메시지 보내기" 화면으로 이동한다.
			intent = new Intent(CoughActivityBase.this, coms0100a.class);
			startActivity(intent);
			
			break;
		case R.string.cough_optionmenu_item_id_receivedmessage:
			// "받은 메시지" 화면으로 이동한다.
			intent = new Intent(CoughActivityBase.this, coms0200a.class);
			startActivity(intent);
			
			break;
		case R.string.cough_optionmenu_item_id_patient:
			// "환자 선택" 화면으로 이동한다.
			intent = new Intent(CoughActivityBase.this, copa0100a.class);
			startActivity(intent);
			
			break;
		case R.string.cough_optionmenu_item_id_preferences:
			// "사용 환경" 화면으로 이동한다.
			intent = new Intent(CoughActivityBase.this, copr0000a.class);
			startActivity(intent);
			
			break;
		case R.string.cough_optionmenu_item_id_help:
			// "도움말" 화면으로 이동한다.
			
			break;
		}
		
		return super.onOptionsItemSelected(item);
	}
	
/* region 메서드이다. *****************************************************************************************************/
	
	/**
	 * 환자의 고유번호를 가져온다.
	 */
	protected int getPatientNo() {
		return PreferenceUtil.getInstance().getPatientNo(this);	
	}
	
	/**
	 * 환자의 ID 를 가져온다.
	 */
	protected String getPatientId() {
		return PreferenceUtil.getInstance().getPatientId(this);	
	}
	
	/**
	 * 환자의 이름을 가져온다.
	 */
	protected String getPatientName() {
		return PreferenceUtil.getInstance().getPatientName(this);	
	}
	
	/**
	 * 환자의 기본정보를 가져온다.
	 */
	protected String getPatientShortInfo() {
		return PreferenceUtil.getInstance().getPatientShortInfo(this);	
	}
	
	/**
	 * 제목(상태) 바에 환자의 기본정보를 설정한다.
	 */
	protected void setTitleStatusBarPatientInfo() {
		if (getPatientNo() == 0) {
			_TextViewCoughTitleStatusBarPatientInfo.setText("There is no selected patient.");
			
			return;
		}
		
		// 환자의 기본정보를 보여준다.
		_TextViewCoughTitleStatusBarPatientInfo.setText(getPatientShortInfo());
	}
}