package kr.nipa.smartui.phone.framework.common;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class ListAdapter1 extends ArrayAdapter<ListItem> {
	private Context _Context;
	private int _Layout;
	private ArrayList<ListItem> _Source;
	
	public ListAdapter1(Context context, int layout, ArrayList<ListItem> source) {
		super(context, layout, source);
		
		_Context = context;
		_Layout = layout;
		_Source = source;
	}

	@Override
	public int getCount() {
		return _Source.size();
	}

	@Override
	public ListItem getItem(int position) {
		if (position <= -1) return null;
			
		return _Source.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}
	
	public int getItemIndex(int no) {
		int index = -1;
		
		for (int i = 0; i <= _Source.size() - 1; i++) {
			ListItem listItem = _Source.get(i);
			if (listItem.getNo() == no)
			{
				index = i;
				
				break;
			}
		}
		
		return index;
	}
	
	public int getItemIndex(String code) {
		int index = -1;
		
		for (int i = 0; i <= _Source.size() - 1; i++) {
			ListItem listItem = _Source.get(i);
			if (listItem.getCode() == code)
			{
				index = i;
				
				break;
			}
		}
		
		return index;
	}

	public int getItemNo(int position) {
		if (position <= -1) return 0;
		
		ListItem listItem = _Source.get(position);
		return listItem.getNo();
	}
	
	public String getItemCode(int position) {
		if (position <= -1) return "";
		
		ListItem listItem = _Source.get(position);
		return listItem.getCode();
	}
	
	public String getItemName(int position) {
		if (position <= -1) return "";
		
		ListItem listItem = _Source.get(position);
		return listItem.getName();
	}
	
	public String getItemDesc(int position) {
		if (position <= -1) return "";
		
		ListItem listItem = _Source.get(position);
		return listItem.getDesc();
	}
	
	@Override
	public int getViewTypeCount() {
		return 1;
	}
	
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View view = convertView;
		
		if (view == null) {
			LayoutInflater inflater = (LayoutInflater)_Context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
			view = inflater.inflate(_Layout, parent, false);
		}
		
		TextView txtItemName = (TextView)view.findViewById(R.id.textViewCommonListItem1Text);
		txtItemName.setText(getItemName(position));
		
		return view;
	}
}