package kr.nipa.smartui.phone.framework.util;

import kr.nipa.smartui.phone.R;
import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;

public class PreferenceUtil {
	private static PreferenceUtil instance = null;
	
	/**
	 * 생성자
	 */
	private PreferenceUtil() {}
	
	/**
	 * 클占쏙옙占쏙옙占쏙옙 占싸쏙옙占싹쏙옙占쏙옙 占쏙옙占싼댐옙
	 */
	public static PreferenceUtil getInstance() 
	{
		if (instance == null) 
		{
			synchronized (PreferenceUtil.class) 
			{
				instance = new PreferenceUtil();
			}
		}
		
		return instance;
	}

/* region 메서드이다. *****************************************************************************************************/
	
	public String getLengthUnit(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_lengh_unit", context.getString(R.string.item_length_unit_cm));
	}
	
	public String getWeighUnit(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_weigh_unit", context.getString(R.string.item_weigh_unit_kg));
	}
	
	public String getPressureUnit(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_pressure_unit", context.getString(R.string.item_pressure_unit_cmH2O));
	}
	
	public String getHospitalCode(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_hospital_code", "");
	}
	
	public String getDoctorId(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_user_id", "");
	}
	
	public String getDoctorName(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_user_name", "");
	}
	
	public int getPatientNo(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getInt("cough_preference_patient_no", 0);
	}
	
	public String getPatientId(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_patient_id", "");
	}
	
	public String getPatientName(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_patient_name", "");
	}
	
	public String getPatientShortInfo(Context context) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		return preference.getString("cough_preference_patient_shortinfo", "");
	}
	
	public void setLengthUnit(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_lengh_unit", value);
		preferenceEditor.commit();
	}
	
	public void setWeighUnit(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_weigh_unit", value);
		preferenceEditor.commit();
	}
	
	public void setPressureUnit(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_pressure_unit", value);
		preferenceEditor.commit();
	}
	
	public void setHospitalCode(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_hospital_code", value);
		preferenceEditor.commit();
	}
	
	public void setDoctorId(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_user_id", value);
		preferenceEditor.commit();
	}
	
	public void setDoctorName(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_user_name", value);
		preferenceEditor.commit();
	}
	
	public void setPatientNo(Context context, int value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putInt("cough_preference_patient_no", value);
		preferenceEditor.commit();
	}
	
	public void setPatientId(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_patient_id", value);
		preferenceEditor.commit();
	}
	
	public void setPatientName(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_patient_name", value);
		preferenceEditor.commit();
	}
	
	public void setPatientShortInfo(Context context, String value) {
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(context);
		
		SharedPreferences.Editor preferenceEditor = preference.edit();
		preferenceEditor.putString("cough_preference_patient_shortinfo", value);
		preferenceEditor.commit();
	}
}