package kr.nipa.smartui.phone.ui.cough.message;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

public class MessageListAdapter extends ArrayAdapter<MessageListItem> {
	private Context _Context;
	private int _Layout;
	private ArrayList<MessageListItem> _Source;
	
	protected View.OnClickListener _ListItemViewClickListener = null;
	
	public MessageListAdapter(Context context, int layout, ArrayList<MessageListItem> source, View.OnClickListener listItemViewClickListener) {
		super(context, layout, source);
		
		_Context = context;
		_Layout = layout;
		_Source = source;
		
		_ListItemViewClickListener = listItemViewClickListener;
	}

	@Override
	public int getCount() {
		return _Source.size();
	}

	@Override
	public MessageListItem getItem(int position) {
		if (position <= -1) return null;
			
		return _Source.get(position);
	}

	@Override
	public long getItemId(int position) {
		return position;
	}

	public int getItemIndex(int no) {
		int index = -1;
		
		for (int i = 0; i <= _Source.size() - 1; i++) {
			MessageListItem listItem = _Source.get(i);
			if (listItem.getNo() == no)
			{
				index = i;
				
				break;
			}
		}
		
		return index;
	}
	
	public int getItemNo(int position) {
		if (position <= -1) return 0;
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getNo();
	}
	
	public String getTypeCd(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getTypeCd();
	}
	
	public String getName(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getName();
	}
	
	public String getContents(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getContents();
	}
	
	public String getReceivedDateTime(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getReceivedDateTime();
	}
	
	public String getReceiverId(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getReceiverId();
	}
	
	public String getSenderId(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getSenderId();
	}
	
	public String getSenderName(int position) {
		if (position <= -1) return "";
		
		MessageListItem listItem = _Source.get(position);
		return listItem.getSenderName();
	}
	
	@Override
	public int getViewTypeCount() {
		return 2;
	}
	
	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		View view = convertView;
		
		try {
//		if (view == null) {
			if (position == 0) {
				LayoutInflater inflater = (LayoutInflater)_Context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				view = inflater.inflate(R.layout.cough_messagelist_list_item_title, parent, false);
			}
			else if (position >= 1) {
				LayoutInflater inflater = (LayoutInflater)_Context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				view = inflater.inflate(_Layout, parent, false);
			}
//		}
		
		TextView textViewItemReceivedDateTime = null;
		TextView textViewItemContents = null;
		TextView textViewItemSenderName = null;
		TextView textViewItemTypeName = null;
		
		if (position == 0) {
//			textItemName = (TextView)view.findViewById(R.id.textViewCommonListItemAddText);
//			textItemName.setText(getItemDesc(position));
		}
		else if (position >= 1) {
			textViewItemReceivedDateTime = (TextView)view.findViewById(R.id.textViewItemReceivedDateTime1);
			textViewItemContents = (TextView)view.findViewById(R.id.textViewItemContents1);
			textViewItemSenderName = (TextView)view.findViewById(R.id.textViewItemSenderName1);
			textViewItemTypeName = (TextView)view.findViewById(R.id.textViewItemTypeName1);
			
//			textViewItemReceivedDateTime.setText(DateFormat.getDateFormat(_Context).format(DateTimeUtil.getInstance().getDate(getReceivedDateTime(position))));
			textViewItemReceivedDateTime.setText(getReceivedDateTime(position));
			textViewItemContents.setText(getContents(position));
			textViewItemSenderName.setText(getSenderName(position) + "[" + getSenderId(position) + "]");
			textViewItemTypeName.setText(getTypeCd(position).equals("1") ? "Text" : "Voice");
		}
		}
		catch (Exception ex) {
			Log.d("Smart UIX", "getView");
		}
		
		return view;
	}
}