package kr.nipa.smartui.phone.ui.cough.message;

import java.io.FileDescriptor;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.ActivityBase;

import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;
import kr.nipa.smartui.phone.framework.util.DateTimeUtil;
import kr.nipa.smartui.phone.framework.util.IoUtil;
import kr.nipa.smartui.phone.framework.util.PreferenceUtil;
import kr.nipa.smartui.phone.ui.Application;
import android.database.Cursor;
import android.graphics.drawable.AnimationDrawable;
import android.media.MediaRecorder;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

public class coms0101a extends ActivityBase {
	private DbOpenHelper _DbOpenHelper = null;
	
	private TextView _TextViewTitle = null;
	private ImageView _ImageViewButtonMic = null;
	
	private LinearLayout _LinearLayoutTextContents = null;
	private EditText _EditTextContents = null;
	private LinearLayout _LinearLayoutVoiceContents = null;
	private ImageView _ImageViewButtonRecord = null;
	private AnimationDrawable _AnimationDrawableButtonRecord = null;
	
	private ImageView _ImageViewButtonSend = null;
	private ImageView _ImageViewButtonCancel = null;
	
//	String _HospitalCode = "";
//	String _DoctorId = "";
//	String _DoctorName = "";
	
	private MediaRecorder _AudioRecorder = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);        
		setContentView(R.layout.ui_coms0101a);
		
		try {
			_DbOpenHelper = new DbOpenHelper(this);
			
			_LinearLayoutTextContents = (LinearLayout)findViewById(R.id.linearLayoutTextContents);
			_ImageViewButtonMic = (ImageView)findViewById(R.id.imageViewButtonMic);
			_LinearLayoutVoiceContents = (LinearLayout)findViewById(R.id.linearLayoutVoiceContents);
			_ImageViewButtonRecord = (ImageView)findViewById(R.id.imageViewButtonRecord);
			
			_TextViewTitle = (TextView)findViewById(R.id.textViewTitle);
			_EditTextContents = (EditText)findViewById(R.id.editTextContents);
			
			_ImageViewButtonSend = (ImageView)findViewById(R.id.imageViewButtonSend);
			_ImageViewButtonCancel = (ImageView)findViewById(R.id.imageViewButtonCancel);
			
			findViewById(R.id.imageViewButtonMic).setOnClickListener(ButtonClickListner);	
			findViewById(R.id.imageViewButtonRecord).setOnClickListener(ButtonClickListner);	
			findViewById(R.id.imageViewButtonSend).setOnClickListener(ButtonClickListner);
			findViewById(R.id.imageViewButtonCancel).setOnClickListener(ButtonClickListner);
			
//        	// 초기화한다.
//        	initialize();
		}
		catch (Exception ex) {
			showOkDialogError(ex);
		}
    }
	
	@Override
    public void onResume() {
		if (_AnimationDrawableButtonRecord != null) {
			if (_AnimationDrawableButtonRecord.isRunning()) _AnimationDrawableButtonRecord.stop();
			
//			_ImageViewButtonRecord.setBackgroundResource(R.drawable.cough_sendmessage_button_record_anim);
		}
    	
    	int patientNo = PreferenceUtil.getInstance().getPatientNo(this);
    	if (patientNo == 0) {
    		_TextViewTitle.setText("There is no selected patient.");
			_ImageViewButtonMic.setEnabled(false);
		
			_EditTextContents.setText("");
			_EditTextContents.setEnabled(false);
			
			_ImageViewButtonSend.setEnabled(false);
    	}
    	
    	// 초기화한다.
    	initialize();
    	
    	super.onResume();
    }
	
	@Override
	public void onPause() {
    	super.onPause();
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	private View.OnClickListener ButtonClickListner = new View.OnClickListener() {		
		@Override
		public void onClick(View view) {
			try {
				switch (view.getId()) {
				case R.id.imageViewButtonMic:
					_ImageViewButtonMic.setEnabled(false);
					
					_LinearLayoutTextContents.setVisibility(View.GONE);
					_LinearLayoutVoiceContents.setVisibility(View.VISIBLE);
					
					// 녹음을 시작한다.
					startRecord();
					
					break;
				case R.id.imageViewButtonRecord:
					if (_ImageViewButtonRecord.getTag().toString().equals("stop"))
					{
						// 녹음을 시작한다.
						startRecord();
					}
					else {
						// 녹음을 중지한다.
						stopRecord();
					}
					
					break;
				case R.id.imageViewButtonSend:
					if (_ImageViewButtonMic.isEnabled()) {
						String hospitalCode = PreferenceUtil.getInstance().getHospitalCode(coms0101a.this);
						String patientId = PreferenceUtil.getInstance().getPatientId(coms0101a.this);
						String patientName = PreferenceUtil.getInstance().getPatientName(coms0101a.this);
						
						// 텍스트메시지를 전송한다.
						((Application)getApplication()).getMessageReceiverController().SendTextMessageTransformReq("p", hospitalCode, patientId, _EditTextContents.getText().toString());
						
						// 정상 전송메시지를 보여준다.
						Toast.makeText(coms0101a.this,  "Send successfully.", Toast.LENGTH_SHORT).show();
						
						_EditTextContents.setText("");
					}
					else {						
						// 녹음을 중지한다.
						if (_ImageViewButtonRecord.getTag().toString().equals("start")) stopRecord();
						
						Date now = DateTimeUtil.getInstance().getNowDateTime();
						SimpleDateFormat nowDateTimeFormat = new SimpleDateFormat("yyyyMMdd_HHmmss");
						
						String hospitalCode = PreferenceUtil.getInstance().getHospitalCode(coms0101a.this);
						String patientId = PreferenceUtil.getInstance().getPatientId(coms0101a.this);
//						String patientName = PreferenceUtil.getInstance().getPatientName(coms0101a.this);
						
						String targetFile = "p" + "_" + hospitalCode + "_" + patientId + "_" + nowDateTimeFormat.format(now) + ".3gp";
						
						// 음성메시지 파일을 서버에 업로드한다.
						IoUtil.getInstance(coms0101a.this).HttpApplicationFileUpload("tmp.3gp", targetFile);
						
						// 음성메시지를 전송한다.
						((Application)getApplication()).getMessageReceiverController().SendVoiceMessageTransformReq("p", hospitalCode, patientId, "http://210.115.36.207/files/" + targetFile);
						
						_ImageViewButtonMic.setEnabled(true);
						
						_LinearLayoutTextContents.setVisibility(View.VISIBLE);
						_LinearLayoutVoiceContents.setVisibility(View.GONE);
					}
					
					break;
				case R.id.imageViewButtonCancel:
					if (_ImageViewButtonMic.isEnabled()) {
						_EditTextContents.setText("");
					}
					else {						
						// 녹음을 중지한다.
						if (_ImageViewButtonRecord.getTag().toString().equals("start")) stopRecord();
						
						_ImageViewButtonMic.setEnabled(true);
						
						_LinearLayoutTextContents.setVisibility(View.VISIBLE);
						_LinearLayoutVoiceContents.setVisibility(View.GONE);
					}
					
					break;
				}				
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
/* region 메서드이다. *****************************************************************************************************/
	
	/**
	 * 초기화한다.
	 */
	private void initialize() {
		Cursor cursor = null;
		
		try {
			_ImageViewButtonMic.setEnabled(false);	// 임시 ...
			
			_LinearLayoutTextContents.setVisibility(View.VISIBLE);
			_LinearLayoutVoiceContents.setVisibility(View.GONE);
			_ImageViewButtonRecord.setTag("stop");
			
			String hospitalCode = PreferenceUtil.getInstance().getHospitalCode(coms0101a.this);
			String id = PreferenceUtil.getInstance().getDoctorId(coms0101a.this);
//			String doctorName = PreferenceUtil.getInstance().getDoctorName(coms0101a.this);
			
			int patientNo = PreferenceUtil.getInstance().getPatientNo(this);
			String patientId = PreferenceUtil.getInstance().getPatientId(this);
			String patientName = PreferenceUtil.getInstance().getPatientName(this);
			
			if (hospitalCode.isEmpty() || id.isEmpty()) {
				_ImageViewButtonMic.setEnabled(false);
				
				_EditTextContents.setText("");
				_EditTextContents.setEnabled(false);
				
				_ImageViewButtonSend.setEnabled(false);
				_ImageViewButtonCancel.setEnabled(false);
				
				if (patientNo != 0) {
					_TextViewTitle.setText("To. " + patientName + "[" + patientId + "]");
				}
				else {
					_TextViewTitle.setText("There is no selected patient.");
				}
			}
			else {
				if (patientNo != 0) {
					_TextViewTitle.setText("To. " + patientName + "[" + patientId + "]");
					_ImageViewButtonMic.setEnabled(true);
				
					_EditTextContents.setText("");
					_EditTextContents.setEnabled(true);
					
					_ImageViewButtonSend.setEnabled(true);
					_ImageViewButtonCancel.setEnabled(true);
				}
				else {
					_TextViewTitle.setText("There is no selected patient.");
					_ImageViewButtonMic.setEnabled(false);
				
					_EditTextContents.setText("");
					_EditTextContents.setEnabled(false);
					
					_ImageViewButtonSend.setEnabled(false);
					_ImageViewButtonCancel.setEnabled(false);
				}
			}
		} finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
	
	private void startRecord() throws IllegalStateException, IOException {
		FileOutputStream fos = IoUtil.getInstance(this).createApplicationFile("tmp.3gp");
		FileDescriptor fd = fos.getFD();
		
		// 녹음 에니메이션을 시작한다.
		_AnimationDrawableButtonRecord = (AnimationDrawable)_ImageViewButtonRecord.getBackground();
		_ImageViewButtonRecord.post(new Runnable() {
			@Override
			public void run() {
				_AnimationDrawableButtonRecord.start();
			}
		});
		
		// 녹음을 시작한다.
		_AudioRecorder = new MediaRecorder();
		_AudioRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
        _AudioRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
        _AudioRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);        
        _AudioRecorder.setOutputFile(fd);
        
        _AudioRecorder.prepare();
        _AudioRecorder.start();
        
        _ImageViewButtonRecord.setTag("start");
	}
	
	private void stopRecord() {
		// 녹음을 중지한다.
		_AudioRecorder.stop();
//		_AudioRecorder.release();
		_AudioRecorder.reset();
		_AudioRecorder = null;
		
		if (_AnimationDrawableButtonRecord != null) {
			if (_AnimationDrawableButtonRecord.isRunning()) _AnimationDrawableButtonRecord.stop();
			
//			_ImageViewButtonRecord.setBackgroundResource(R.drawable.cough_sendmessage_button_record_anim);
		}
		
		_ImageViewButtonRecord.setTag("stop");
		
//		MediaStore.Audio.Media.DATA;
	}
}