package kr.nipa.smartui.phone.ui.cough.message;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.ActivityBase;

import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;
import kr.nipa.smartui.phone.framework.util.DateTimeUtil;
import kr.nipa.smartui.phone.framework.util.IoUtil;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.os.Environment;
import android.text.format.DateFormat;
import android.view.ContextMenu;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.DatePicker;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

public class coms0201a extends ActivityBase {
	private DbOpenHelper _DbOpenHelper = null;
	
	private CheckBox _CheckBoxLatest = null;
	private LinearLayout _LinearLayoutButtonCalendarFrom = null;
	private ImageView _ImageViewButtonCalendarFrom = null;
	private LinearLayout _LinearLayoutButtonValueCalendarFrom = null;
	private TextView _TextViewButtonValueCalendarFrom = null;
	private LinearLayout _LinearLayoutButtonCalendarTo = null;
	private ImageView _ImageViewButtonCalendarTo = null;
	private LinearLayout _LinearLayoutButtonValueCalendarTo = null;
	private TextView _TextViewButtonValueCalendarTo = null;
	
	private ListView _ListView = null;
	
	private MessageListAdapter _ListAdapter = null;
	private ArrayList<MessageListItem> _ListItems = null;
//	private ArrayList<MessageListItem> _SelectedListItems = null;
	
	private int _SelectedDateTextViewId = -1;
	
	private int _SelectedListItemIndex = -1;
	private int _SelectedContextMenuItemIndex = -1;
	
	private MediaPlayer _VoiceMessagePlayer = null;
	
	private final int _OKDIALOG_ID = 11;
	private final int _OKDIALOG_PLAYMESSAGE_ID = 16;
	private final int _OKDIALOG_DATE_ID = 51;
	
	private DialogInterface.OnClickListener _DialogButtonClickListener = null;
	private DatePickerDialog.OnDateSetListener _DateDialogDateSetListener = null;	
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);        
		setContentView(R.layout.ui_coms0201a);
		
		try {
			_DbOpenHelper = new DbOpenHelper(this);
			
			_CheckBoxLatest = (CheckBox)findViewById(R.id.checkBoxLatest);
			_LinearLayoutButtonCalendarFrom = (LinearLayout)findViewById(R.id.linearLayoutButtonCalendarFrom);
			_ImageViewButtonCalendarFrom = (ImageView)findViewById(R.id.imageViewButtonCalendarFrom);
			_LinearLayoutButtonValueCalendarFrom = (LinearLayout)findViewById(R.id.linearLayoutButtonValueCalendarFrom);
			_TextViewButtonValueCalendarFrom = (TextView)findViewById(R.id.textViewButtonValueCalendarFrom);
			_LinearLayoutButtonCalendarTo = (LinearLayout)findViewById(R.id.linearLayoutButtonCalendarTo);
			_ImageViewButtonCalendarTo = (ImageView)findViewById(R.id.imageViewButtonCalendarTo);
			_LinearLayoutButtonValueCalendarTo = (LinearLayout)findViewById(R.id.linearLayoutButtonValueCalendarTo);
			_TextViewButtonValueCalendarTo = (TextView)findViewById(R.id.textViewButtonValueCalendarTo);
			
			_ListView = (ListView)findViewById(R.id.listViewData);
			
			_CheckBoxLatest.setOnCheckedChangeListener(ButtonCheckedChangedListner);
			_ImageViewButtonCalendarFrom.setOnClickListener(ButtonClickListner);
			_ImageViewButtonCalendarTo.setOnClickListener(ButtonClickListner);
        	
        	_ListView.setOnItemClickListener(ListItemClickListner);
        	
        	// 컨텍스트 메뉴를 등록한다.
        	registerForContextMenu(_ListView);
        	
        	// 초기화한다.
        	initialize();
		}
		catch (Exception ex) {
			showOkDialogError(ex);
		}
    }
	
	@Override
    public void onResume() {
    	super.onResume();
    	
    	// 데이터 목록을 바인딩한다.
    	bindDataList();
    }
	
	@Override
	public void onPause() {
    	super.onPause();
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	private View.OnClickListener ButtonClickListner = new View.OnClickListener() {		
		@Override
		public void onClick(View view) {
//			Intent intent = null;
			
			try {
				Date date = null;
				
				switch (view.getId()) {
				case R.id.imageViewButtonCalendarFrom:
					_SelectedDateTextViewId = R.id.imageViewButtonCalendarFrom;
					
					showOkDialogDate(getString(R.string.shortmessage_Select_date), DateSetListener);	
					
					break;
				case R.id.imageViewButtonCalendarTo:
					_SelectedDateTextViewId = R.id.imageViewButtonCalendarTo;
					
					showOkDialogDate(getString(R.string.shortmessage_Select_date), DateSetListener);	
					
					break;
				}
				
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
	private CompoundButton.OnCheckedChangeListener ButtonCheckedChangedListner = new CompoundButton.OnCheckedChangeListener() {		
		@Override
		public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
			try {
				if (isChecked) {
					_LinearLayoutButtonCalendarFrom.setBackgroundColor(0xff393939);
					_ImageViewButtonCalendarFrom.setEnabled(false);
					_LinearLayoutButtonValueCalendarFrom.setBackgroundColor(0xff393939);
					_LinearLayoutButtonCalendarTo.setBackgroundColor(0xff393939);
					_ImageViewButtonCalendarTo.setEnabled(false);
					_LinearLayoutButtonValueCalendarTo.setBackgroundColor(0xff393939);
				}
				else {
					_LinearLayoutButtonCalendarFrom.setBackgroundColor(0xff436da5);
					_ImageViewButtonCalendarFrom.setEnabled(true);
					_LinearLayoutButtonValueCalendarFrom.setBackgroundColor(0xff7a9ddb);
					_LinearLayoutButtonCalendarTo.setBackgroundColor(0xff436da5);
					_ImageViewButtonCalendarTo.setEnabled(true);
					_LinearLayoutButtonValueCalendarTo.setBackgroundColor(0xff7a9ddb);
				}
				
				// 데이터 목록을 바인딩한다.
		    	bindDataList();
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
	private DatePickerDialog.OnDateSetListener DateSetListener = new DatePickerDialog.OnDateSetListener() {
		@Override
		public void onDateSet(DatePicker view, int year, int monthOfYear, int dayOfMonth) {
			try {
				Date date = null;
				SimpleDateFormat dateFormat = null;
				
				switch (_SelectedDateTextViewId) {
				case R.id.imageViewButtonCalendarFrom:	
					date = new Date();
					date.setYear(year - 1900);
					date.setMonth(monthOfYear);
					date.setDate(dayOfMonth);
					date.setHours(0);
					date.setMinutes(0);
					date.setSeconds(0);
					
					dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
					
					_TextViewButtonValueCalendarFrom.setTag(dateFormat.format(date));
					_TextViewButtonValueCalendarFrom.setText(DateFormat.getDateFormat(coms0201a.this).format(date).toString());
					
					break;
				case R.id.imageViewButtonCalendarTo:
					date = new Date();
					date.setYear(year - 1900);
					date.setMonth(monthOfYear);
					date.setDate(dayOfMonth);
					date.setHours(23);
					date.setMinutes(59);
					date.setSeconds(59);
					
					dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
					
					_TextViewButtonValueCalendarTo.setTag(dateFormat.format(date));
					_TextViewButtonValueCalendarTo.setText(DateFormat.getDateFormat(coms0201a.this).format(date).toString());
					
					break;
				}
				
				// 데이터 목록을 바인딩한다.
		    	bindDataList();
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};
	
	private AdapterView.OnItemClickListener ListItemClickListner = new AdapterView.OnItemClickListener() {	
		@Override
		public void onItemClick(AdapterView parent, View v, int position, long id) {
			try {	
				_SelectedListItemIndex = position;
				
				if (_VoiceMessagePlayer != null && _VoiceMessagePlayer.isPlaying()) _VoiceMessagePlayer.release(); _VoiceMessagePlayer = null;
				
				if (_SelectedListItemIndex == 0) {
					return;
				}
				else {
					// 메시지를 확인한다.
					if (_ListAdapter.getItem(_SelectedListItemIndex).getTypeCd().equals("1")) {
						showMyOkDialog("Show text message", _ListAdapter.getItem(_SelectedListItemIndex).getContents(), DialogButtonClickListner);
					}
					else {
						if (!IoUtil.getInstance(coms0201a.this).ExternalStorageIsMounted()) {
							showMyOkDialog("Play voice message", getString(R.string.message_Your_machines_external_storage_is_unmounted), null);
							
							return;
						}
						
						// 음성메시지를 재생한다.
						File file = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_DOWNLOADS);
						
						_VoiceMessagePlayer = new MediaPlayer();
						_VoiceMessagePlayer.setDataSource(file.getPath() + "/" + _ListAdapter.getItem(_SelectedListItemIndex).getName());
						
//						showMyOkDialog("Play voice message", "The voice message is playing ...", PlayMessageDialogButtonClickListner);
						
						_VoiceMessagePlayer.prepare();
						_VoiceMessagePlayer.start();
					}
				}
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);
		
		menu.add(0, R.string.contextmenu_item_id_delete, 0, R.string.contextmenu_item_text_delete);
		
		_SelectedContextMenuItemIndex = ((AdapterView.AdapterContextMenuInfo)menuInfo).position;
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
		try {
			switch (item.getItemId()) {
			case R.string.contextmenu_item_id_delete:
				// 메시지를 삭제한다.
				DeleteData(_ListItems.get(_SelectedContextMenuItemIndex).getNo());
				
				// 데이터 목록을 바인딩한다.
				bindDataList();
				
				// 정상 삭제메시지를 보여준다.
				Toast.makeText(coms0201a.this, R.string.message_Deleted_from_tilde, Toast.LENGTH_SHORT).show();
				
				break;
			}
		}
		catch (Exception ex) {
			showMyOkDialogError(ex);
		}
		
		return true;
	}
	
	DialogInterface.OnClickListener DialogButtonClickListner = new DialogInterface.OnClickListener() {		
		@Override
		public void onClick(DialogInterface dialog, int whichButton) {		
			Intent intent = null;
			
			try {
				switch (whichButton) {
				case DialogInterface.BUTTON_POSITIVE:
					//
					
					break;
				}
			}
			catch (Exception ex) {
				showMyOkDialogError(ex);
			}
		}
	};
	
	DialogInterface.OnClickListener PlayMessageDialogButtonClickListner = new DialogInterface.OnClickListener() {		
		@Override
		public void onClick(DialogInterface dialog, int whichButton) {		
			Intent intent = null;
			
			try {
				switch (whichButton) {
				case DialogInterface.BUTTON_POSITIVE:
					// 메시지 재생을 중지한다.
					_VoiceMessagePlayer.release();
					
					break;
				}
			}
			catch (Exception ex) {
				showMyOkDialogError(ex);
			}
		}
	};
	
	@Override
	protected Dialog onCreateDialog(int id, Bundle args) {
		super.onCreateDialog(id);
		
		AlertDialog dialog = null;
		
		LayoutInflater layoutInflater = null;		
		View view = null;
		
		switch (id) {
		case _OKDIALOG_ID:			
			dialog = new AlertDialog.Builder(getParent())
//					 .setCustomTitle(viewTitle)
					 .setTitle(args.getCharSequence("arg1"))
					 .setMessage(args.getCharSequence("arg2"))
			         .setPositiveButton(android.R.string.ok, _DialogButtonClickListener)
			         .create();		       
			
			break;
//		case _OKDIALOG_PLAYMESSAGE_ID:
//			layoutInflater = (LayoutInflater)getSystemService(LAYOUT_INFLATER_SERVICE);
//			view = layoutInflater.inflate(R.layout.common_okdialog_password, null);	
//			
////			_EditTextOkDialogPassword = (EditText)view.findViewById(R.id.editTextCommonOkDialogPassword);  
//			
//			dialog = new AlertDialog.Builder(this)
////					 .setCustomTitle(viewTitle)
//					 .setView(view)
//					 .setTitle(args.getCharSequence("arg1"))
//			         .setPositiveButton(android.R.string.ok, _DialogButtonClickListener)
//			         .create();		       
//			
//			break;
		case _OKDIALOG_DATE_ID:
			int year = args.getInt("arg2");
			int month = args.getInt("arg3");
			int day = args.getInt("arg4");
			
			dialog = new DatePickerDialog(getParent(), _DateDialogDateSetListener, year, month, day);
			dialog.setTitle(args.getString("arg1"));
			
			break;
		}
		
		return dialog;
	}
	
	@Override
	protected void onPrepareDialog(int id, Dialog dialog, Bundle args) {
		super.onPrepareDialog(id, dialog);
		
		switch (id) {
		case _OKDIALOG_ID:
//			((AlertDialog)dialog).setTitle(args.getCharSequence("arg1"));
			((AlertDialog)dialog).setMessage(args.getCharSequence("arg2"));
			
			break;
//		case _OKDIALOG_PLAYMESSAGE_ID:			
////			_EditTextOkDialogPassword.setText("");
//			
//			break;
		}
	}
	
///* region 메서드이다. *****************************************************************************************************/
	
	/**
	 * 초기화한다.
	 */
	private void initialize() {
		_CheckBoxLatest.setChecked(false);
		
		Date now = DateTimeUtil.getInstance().getNowDateTime();
		SimpleDateFormat nowDateTimeFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");		
		
		now.setHours(0);
		now.setMinutes(0);
		now.setSeconds(0);
		
		_TextViewButtonValueCalendarFrom.setTag(nowDateTimeFormat.format(now));
		_TextViewButtonValueCalendarFrom.setText(DateFormat.getDateFormat(coms0201a.this).format(now).toString());
		
		now.setHours(23);
		now.setMinutes(59);
		now.setSeconds(59);
		
		_TextViewButtonValueCalendarTo.setTag(nowDateTimeFormat.format(now));
		_TextViewButtonValueCalendarTo.setText(DateFormat.getDateFormat(coms0201a.this).format(now).toString());
    }
	
	/**
	 * 데이터 목록을 바인딩한다.
	 */
	private void bindDataList() {
		Cursor cursor = null;
		
		try {
			// 목록을 가져온다.	
			cursor = getDataList();
			
	    	// 목록을 바인딩한다.
			_ListItems = new ArrayList<MessageListItem>();
			
			_ListItems.add(new MessageListItem(0, "", "", "", "", "", "", ""));
			
			while (cursor.moveToNext()) {				
		        _ListItems.add(new MessageListItem(cursor.getInt(0),
												   cursor.getString(1),
												   cursor.getString(2),
												   cursor.getString(3),
												   cursor.getString(4),
												   cursor.getString(5),
												   cursor.getString(6),
												   cursor.getString(7)));
			}
			
			_ListAdapter = new MessageListAdapter(this, R.layout.cough_messagelist_list_item, _ListItems, null); 
	        _ListView.setAdapter(_ListAdapter);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
	
	private void showMyOkDialog(String title, String message, DialogInterface.OnClickListener dialogButtonClickListener) {
		Bundle args = new Bundle();
		args.putString("arg1", title);
		args.putString("arg2", message);
		
		_DialogButtonClickListener = dialogButtonClickListener;
		
		showDialog(_OKDIALOG_ID, args);
	}
	
//	private void showMyOkDialogPlayMessage(String title, byte[] data, DialogInterface.OnClickListener dialogButtonClickListener) {
////		Bundle args = new Bundle();
////		args.putString("arg1", title);
////		args.putString("arg2", message);
////		
////		_DialogButtonClickListener = dialogButtonClickListener;
////		
////		showDialog(_OKDIALOG_PLAYMESSAGE_ID, args);
//	}
	
	private void showMyOkDialogDate(String title, DatePickerDialog.OnDateSetListener dateDialogDateSetListener) {
		Calendar cal = Calendar.getInstance();
		int year = cal.get(Calendar.YEAR);
		int month = cal.get(Calendar.MONTH);
		int day = cal.get(Calendar.DAY_OF_MONTH);
		
		Bundle args = new Bundle();
		args.putString("arg1", title);
		args.putInt("arg2", year);
		args.putInt("arg3", month);
		args.putInt("arg4", day);
		
		_DateDialogDateSetListener = dateDialogDateSetListener;
		
		showDialog(_OKDIALOG_DATE_ID, args);
	}
	
	private void showMyOkDialogError(Exception ex) {
		Bundle args = new Bundle();
		args.putString("arg1", getString(R.string.shortmessage_Error));
		args.putString("arg2", ex.getStackTrace().toString() + "\n" + ex.getMessage().toString());
		
		_DialogButtonClickListener = null;
		
		showDialog(_OKDIALOG_ID, args);
	}
	
	/**
	 * 데이터 목록을 가져온다.
	 */
	private Cursor getDataList() {
    	SQLiteDatabase db = null;
    	
		try {
			// 목록을 조회한다.
			String sql = "SELECT No," 								+
								"TypeCd," 							+
								"Name," 							+
                    			"Contents," 						+
			                    "ReceivedDTime," 					+
			                    "ReceiverId," 						+
			                    "SenderId," 						+
			                    "SenderNm " 						+
			             "FROM TbReceivedMessage "					+
			             "ORDER BY ReceivedDTime DESC";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
	
	/**
	 * 데이터를 삭제한다.
	 * 
	 * @param no 번호
	 */
	private void DeleteData(int no) {
    	SQLiteDatabase db = null;
		
		try {
			// 데이터를 삭제한다.
			String sql = "DELETE FROM TbReceivedMessage WHERE No = " + no;
			
			db = _DbOpenHelper.getWritableDatabase();			
			db.execSQL(sql);
		}
		finally {
			if (db != null) db.close(); db = null;
		}
    }
}