package kr.nipa.smartui.phone.ui.cough.patient;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.cough.ListActivityBase;
import kr.nipa.smartui.phone.framework.common.ListItem;
import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;
import kr.nipa.smartui.phone.framework.util.PreferenceUtil;

import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.Toast;

public class copa0100a  extends ListActivityBase {
	private DbOpenHelper _DbOpenHelper = null;
	
	private PatientListAdapter _ListAdapter = null;
	private ArrayList<ListItem> _ListItems = null;
	
	private int _SelectedListItemIndex = -1;
	private int _SelectedContextMenuItemIndex = -1;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        try {
        	_DbOpenHelper = new DbOpenHelper(this);
        	
        	// 컨텍스트 메뉴를 등록한다.
        	registerForContextMenu(getListView());
        	
        	// 초기화한다.
        	initialize();
        }
		catch (Exception ex) {
			showOkDialogError(ex);
		}
    }
	
	@Override
    public void onResume() {
    	super.onResume();
    	
    	// 환자 목록을 바인딩한다.
    	bindPatientList();
    	
//    	// 컨텍스트 메뉴를 등록한다.
//    	registerForContextMenu(getListView());
    }
	
	@Override
	public void onPause() {
    	super.onPause();
    	
//    	// 컨텍스트 메뉴를 해제한다.
//    	unregisterForContextMenu(getListView());
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	@Override
	public void onListItemClick(ListView list, View v, int position, long id) {
		Intent intent = null;
		
		try {	
			_SelectedListItemIndex = position;
			
			if (_SelectedListItemIndex == 0) {
				// "환자 기본정보 등록" 화면으로 이동한다.
				intent = new Intent(this, copa0200a.class);
				startActivity(intent);
			}
			else {
				// 선택된 환자의 기본정보를 사용환경에 설정하고, 화면을 닫는다.
				setPatientInfo(_ListAdapter.getItem(_SelectedListItemIndex));
				
				finish();
			}
		}
		catch (Exception ex) {
			showOkDialogError(ex);
		}
	}
	
	View.OnClickListener ListItemViewClickListener = new View.OnClickListener() {		
		@Override
		public void onClick(View view) {
			try {
				Intent intent = null;
				
				switch (view.getId()) {
				case R.id.imageViewCoughPatientListItemPatientInfo:
					// "환자 기본정보 수정" 화면으로 이동한다.
					intent = new Intent(copa0100a.this, copa0300a.class);
					intent.putExtra("extra1",  _ListAdapter.getItemNo(Integer.parseInt(view.getTag().toString())));
					startActivity(intent);
					
					break;
				}
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
		super.onCreateContextMenu(menu, v, menuInfo);
		
		menu.add(0, R.string.contextmenu_item_id_delete, 0, R.string.contextmenu_item_text_delete);
		menu.add(0, R.string.cough_contextmenu_item_id_reset_selectedpatient, 1, R.string.cough_contextmenu_item_text_reset_selectedpatient);
		
		_SelectedContextMenuItemIndex = ((AdapterView.AdapterContextMenuInfo)menuInfo).position;
	}
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
		try {
			switch (item.getItemId()) {
			case R.string.contextmenu_item_id_delete:
				// 환자의 기본정보를 삭제한다.
				DeletePatientInformation(_ListItems.get(_SelectedContextMenuItemIndex).getNo());
				
				// 환자 목록을 바인딩한다.
				bindPatientList();
				
				// 정상 삭제메시지를 보여준다.
				Toast.makeText(copa0100a.this, R.string.message_Deleted_from_tilde, Toast.LENGTH_SHORT).show();
				
				break;
			case R.string.cough_contextmenu_item_id_reset_selectedpatient:
				// 환자의 기본정보와 관련한 사용환경을 초기화한다.
				PreferenceUtil.getInstance().setPatientNo(copa0100a.this, 0);
				PreferenceUtil.getInstance().setPatientId(copa0100a.this, "");
				PreferenceUtil.getInstance().setPatientName(copa0100a.this, "");
				PreferenceUtil.getInstance().setPatientShortInfo(copa0100a.this, "");
				
				break;
			}
		}
		catch (Exception ex) {
			showOkDialogError(ex);
		}
		
		return true;
	}
	
/* region 메서드이다. *****************************************************************************************************/
	
	/**
	 * 초기화한다.
	 */
	private void initialize() {
//		// 환자 목록을 바인딩한다.
//		bindPatientList();
    }
	
	/**
	 * 환자 목록을 바인딩한다.
	 */
	private void bindPatientList() {
		Cursor cursor = null;
		
		try {
			// 목록을 가져온다.				
			cursor = getPatientList();
	    	
	    	// 목록을 바인딩한다.
			_ListItems = new ArrayList<ListItem>();
			
			_ListItems.add(new ListItem(-1, "", getString(R.string.shortmessage_Add_patient), getString(R.string.shortmessage_Add_patient)));
			
			while (cursor.moveToNext()) {
				int no = cursor.getInt(0);
				String id = cursor.getString(1);
				String name = cursor.getString(2);
				String desc = name + "[" + id + "]     " + cursor.getString(3) + " " + cursor.getString(4) + " " + cursor.getString(5) + "/" + cursor.getString(6) + " " + cursor.getString(7);
				
		        _ListItems.add(new ListItem(no, id, name, desc));
			}
			
	        _ListAdapter = new PatientListAdapter(this, R.layout.cough_patientlist_list_item, _ListItems, ListItemViewClickListener);        
	        setListAdapter(_ListAdapter);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
	
	/**
	 * 환자 목록을 가져온다.
	 */
	private Cursor getPatientList() {
    	SQLiteDatabase db = null;
    	
		try {
	    	// 목록을 조회한다.
			String sql = "SELECT p.No," 					+
			                    "p.Id," 					+
			                    "p.Name," 					+
			                    "c.name GenderNm,"			+
			                    "p.Age," 					+
			                    "p.Height," 				+
			                    "p.Weigh," 					+
			                    "p.Diagnosis " 				+
			         "FROM TbPatient p LEFT OUTER JOIN TbCommonCode c ON p.Gender = c.Code AND c.CategCd = '01'";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 환자 기본정보를 사용환경에 설정한다.
	 */
    private void setPatientInfo(ListItem item) {
    	// 데이터를 사용환경에 설정한다.
		PreferenceUtil.getInstance().setPatientNo(this, item.getNo());
		PreferenceUtil.getInstance().setPatientId(this, item.getCode());
		PreferenceUtil.getInstance().setPatientName(this, item.getName());
		PreferenceUtil.getInstance().setPatientShortInfo(this, item.getDesc());
    }
    
	/**
	 * 환자 기본정보를 삭제한다.
	 * 
	 * @param patientNo 환자 번호
	 */
	private void DeletePatientInformation(int patientNo) {
    	SQLiteDatabase db = null;
		
		try {
			// 데이터를 삭제한다.
			String sql = "DELETE FROM TbPatient WHERE No = " + patientNo;
			
			db = _DbOpenHelper.getWritableDatabase();			
			db.execSQL(sql);
		}
		finally {
			if (db != null) db.close(); db = null;
		}
    }
}