package kr.nipa.smartui.phone.ui.cough.patient;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.ActivityBase;
import kr.nipa.smartui.phone.framework.common.ListItem;
import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class copa0200a extends ActivityBase {
	private DbOpenHelper _DbOpenHelper = null;
	
	private EditText _EditTextId = null;
	private EditText _EditTextName = null;
	private EditText _EditTextAge = null;
	private Spinner _SpinnerSex = null;
	private EditText _EditTextHeight = null;
	private EditText _EditTextWeigh = null;
	private EditText _EditTextDiagnosedDisease = null;
	private Spinner _SpinnerHospital = null;
	
	private ArrayAdapter _SexArrayAdapter = null;
	private ArrayList<ListItem> _SexListItems = null;
	private ArrayAdapter _HospitalArrayAdapter = null;
	private ArrayList<ListItem> _HospitalListItems = null;
	
	private boolean _IsAdded = false;						// 등록 여부이다.
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);     
		setContentView(R.layout.ui_copa0200a);
		
        try {
        	_DbOpenHelper = new DbOpenHelper(this);
        	
        	_EditTextId = (EditText)findViewById(R.id.editTextId);
        	_EditTextName = (EditText)findViewById(R.id.editTextName);
        	_EditTextAge = (EditText)findViewById(R.id.editTextAge);
        	_SpinnerSex = (Spinner)findViewById(R.id.spinnerSex);
        	_EditTextHeight = (EditText)findViewById(R.id.editTextHeight);
        	_EditTextWeigh = (EditText)findViewById(R.id.editTextWeigh);
        	_EditTextDiagnosedDisease = (EditText)findViewById(R.id.editTextDiagnosedDisease);
        	_SpinnerHospital = (Spinner)findViewById(R.id.spinnerHospital);
        	
        	findViewById(R.id.imageViewButtonAdd).setOnClickListener(ButtonClickListner);
 	       	findViewById(R.id.imageViewButtonSave).setOnClickListener(ButtonClickListner);
 	       	
        	// 초기화한다.
        	initialize();
        }
		catch (Exception ex) {
			showOkDialogError(ex);
		}
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	private View.OnClickListener ButtonClickListner = new View.OnClickListener() {		
		@Override
		public void onClick(View view) {
			Intent intent = null;
			
//			Cursor cursor = null;
			
			try {
				switch (view.getId()) {
				case R.id.imageViewButtonAdd:
					// 모든 항목을 초기화한다.
					_EditTextId.setText("");
		        	_EditTextName.setText("");
		        	_EditTextAge.setText("");
		        	_SpinnerSex.setSelection(0);
		        	_EditTextHeight.setText("");
		        	_EditTextWeigh.setText("");
		        	_EditTextDiagnosedDisease.setText("");
		        	_SpinnerHospital.setSelection(0);
		        	
		        	// 아이디와 의료기관 항목을 활성화한다.
		        	_EditTextId.setEnabled(true);
					_SpinnerHospital.setEnabled(true);
					
					// 등록 여부를 설정한다.
					_IsAdded = true;
					
					break;
				case R.id.imageViewButtonSave:
					// 항목 값의 유효성을 검사한다.
					if (_EditTextId.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextId.requestFocus();
						
						return;
					}
					else if (_EditTextName.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextName.requestFocus();
						
						return;
					}
					else if (_EditTextAge.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextAge.requestFocus();
						
						return;
					}
					else if (_SpinnerSex.getCount() < 0) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_SpinnerSex.requestFocus();
						
						return;
					}	
					else if (_EditTextHeight.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextHeight.requestFocus();
						
						return;
					}
					else if (_EditTextWeigh.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextWeigh.requestFocus();
						
						return;
					}
					else if (_SpinnerHospital.getCount() < 0) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_SpinnerHospital.requestFocus();
						
						return;
					}
					else {
						//
					}
					
					// 환자 기본정보를 등록한다.
					registerPatientInformation();
					
					// 아이디와 의료기관 항목을 비활성화한다.
					_EditTextId.setEnabled(false);
					_SpinnerHospital.setEnabled(false);
					
					// 등록 여부를 설정한다.
					_IsAdded = false;
					
					// 정상 등록메시지를 보여준다.
					Toast.makeText(copa0200a.this,  getString(R.string.message_Added_to_tilde), Toast.LENGTH_SHORT).show();
					
					break;
//				case R.id.imageViewCancel:
//					finish();
//					
//					break;
				}
				
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
/* region 메서드이다. *****************************************************************************************************/
    
	/**
	 * 초기화한다.
	 */
    private void initialize() {
//    	Cursor cursor = null;
    	
		try {
	    	// 성별 목록을 바인딩한다.						
			bindSexList();
	        
			// 의료기관 목록을 바인딩한다.						
			bindHospitalList();
 	       
			// 아이디와 의료기관 항목을 비활성화한다.
			_EditTextId.setEnabled(true);
			_SpinnerHospital.setEnabled(true);
			
			// 등록 여부를 설정한다.
			_IsAdded = true;
		}
		finally {
//			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 성별 목록을 바인딩한다.
	 */
    private void bindSexList() {
    	Cursor cursor = null;
    	
		try {
	    	// 목록을 가져온다.						
			cursor = getSexList();
	    				
	    	// 목록을 바인딩한다.	
			ArrayList<CharSequence> genderListItems = new ArrayList<CharSequence>();
			
			_SexListItems = new ArrayList<ListItem>();
			
			while (cursor.moveToNext()) {
				String Code = cursor.getString(0);
				String name = cursor.getString(1);
				
				genderListItems.add(name);
				
				_SexListItems.add(new ListItem(-1, Code, name));
			}
			
//	        _ArrayAdapter = ArrayAdapter.createFromResource(this, android.R.layout.simple_spinner_item); 
			_SexArrayAdapter = new ArrayAdapter(this, android.R.layout.simple_spinner_item, genderListItems);  
			_SexArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	        
	        _SpinnerSex.setAdapter(_SexArrayAdapter);
	        
	        _SpinnerSex.setSelection(0);
	        
//	        _SpinnerGender.setOnItemSelectedListener(SpinnerItemSelectedListener);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 의료기관 목록을 바인딩한다..
	 */
    private void bindHospitalList() {
    	Cursor cursor = null;
    	
		try {
			// 목록을 가져온다.						
 			cursor = getHospitalList();
 	    				
 			// 목록을 바인딩한다.	
 			ArrayList<CharSequence> hospitalListItems = new ArrayList<CharSequence>();
 			
 			_HospitalListItems = new ArrayList<ListItem>();
 			
 			while (cursor.moveToNext()) {
 				String Code = cursor.getString(0);
 				String name = cursor.getString(1);
 				
 				hospitalListItems.add(name);
 				
 				_HospitalListItems.add(new ListItem(-1, Code, name));
 			}
 			
 			_HospitalArrayAdapter = new ArrayAdapter(this, android.R.layout.simple_spinner_item, hospitalListItems);  
 			_HospitalArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
 	        
 	        _SpinnerHospital.setAdapter(_HospitalArrayAdapter);
 	        
// 	       _SpinnerHospital.setOnItemSelectedListener(SpinnerItemSelectedListener);
 	        
 	       _SpinnerHospital.setSelection(0);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 성별 목록을 가져온다.
	 */
    private Cursor getSexList() {
    	SQLiteDatabase db = null;
    	
		try {
	    	// 목록을 조회한다.
			String sql = "SELECT Code," 			+
			                    "Name " 			+
		                 "FROM TbCommonCode "		+
		                 "WHERE CategCd = '01'";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 의료기관 목록을 가져온다.
	 */
    private Cursor getHospitalList() {
    	SQLiteDatabase db = null;
    	
		try {
	    	// 목록을 조회한다.
			String sql = "SELECT Code," 				+
			                    		"Name " 			+
				             "FROM TbHospital "		+
				             "WHERE UseYn = 1";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 환자 기본정보를 등록한다.
	 */
    private void registerPatientInformation() {
    	SQLiteDatabase db = null;
		
		try {
			// 데이터를 등록한다.
			String sql = "INSERT INTO TbPatient (Id," 						+
										                    "Name," 					+
										                    "Gender," 					+
										                    "Age," 						+
										                    "Height," 					+
										                    "Weigh," 					+
										                    "Diagnosis," 				+
										                    "HospitalCd," 				+
										                    "regDTime) " 				+
					                    	 "VALUES ('" + _EditTextId.getText() + "'," 																			+
									                      "'" + _EditTextName.getText() + "'," 																		+
									                      "'" + _SexListItems.get((int)_SpinnerSex.getSelectedItemId()).getCode() + "'," 		+
									                      "'" + _EditTextAge.getText() + "'," 																			+
									                      "'" + _EditTextHeight.getText() + "'," 																		+
									                      "'" + _EditTextWeigh.getText() + "'," 																		+
									                      "'" + _EditTextDiagnosedDisease.getText() + "'," 																	+
									                      "'" + _HospitalListItems.get((int)_SpinnerHospital.getSelectedItemId()).getCode() + "'," 	+
									                      "DATETIME('now'))";
			
			db = _DbOpenHelper.getWritableDatabase();			
			db.execSQL(sql);
		}
		finally {
			if (db != null) db.close(); db = null;
		}
    }
}