package kr.nipa.smartui.phone.ui.cough.patient;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;
import kr.nipa.smartui.phone.framework.base.ActivityBase;
import kr.nipa.smartui.phone.framework.common.ListItem;
import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;
import kr.nipa.smartui.phone.framework.util.ListUtil;

import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

public class copa0300a extends ActivityBase {
	private DbOpenHelper _DbOpenHelper = null;
	
	private EditText _EditTextId = null;
	private EditText _EditTextName = null;
	private EditText _EditTextAge = null;
	private Spinner _SpinnerSex = null;
	private EditText _EditTextHeight = null;
	private EditText _EditTextWeigh = null;
	private EditText _EditTextDiagnosis = null;
	private Spinner _SpinnerHospital = null;
	
	private ArrayAdapter _SexArrayAdapter = null;
	private ArrayList<ListItem> _SexListItems = null;
	private ArrayAdapter _HospitalArrayAdapter = null;
	private ArrayList<ListItem> _HospitalListItems = null;
	
	private int _PatientNo = 0;								// 환자 번호이다.
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);    
//		requestWindowFeature(Window.FEATURE_CUSTOM_TITLE);        
		setContentView(R.layout.ui_copa0300a);
        
//		getWindow().setFeatureInt(Window.FEATURE_CUSTOM_TITLE, R.layout.framework_base_cough_title_bar);        
//		((TextView)findViewById(R.id.textViewCoughTitleBarTitle)).setText(getString(R.string.shortmessage_modify_patient_information));
		
        try {
        	_DbOpenHelper = new DbOpenHelper(this);
        	
        	_EditTextId = (EditText)findViewById(R.id.editTextId);
        	_EditTextName = (EditText)findViewById(R.id.editTextName);
        	_EditTextAge = (EditText)findViewById(R.id.editTextAge);
        	_SpinnerSex = (Spinner)findViewById(R.id.spinnerSex);
        	_EditTextHeight = (EditText)findViewById(R.id.editTextHeight);
        	_EditTextWeigh = (EditText)findViewById(R.id.editTextWeigh);
        	_EditTextDiagnosis = (EditText)findViewById(R.id.editTextDiagnosedDisease);
        	_SpinnerHospital = (Spinner)findViewById(R.id.spinnerHospital);
        	
        	findViewById(R.id.imageViewButtonSave).setOnClickListener(ButtonClickListner);
        				
 	       	// 호출한 화면으로부터 전달된 환자 번호를 변수에 저장한다.
			Intent intent = getIntent();
			_PatientNo = intent.getIntExtra("extra1", 0);
 	    			
        	// 초기화한다.
        	initialize();
        }
		catch (Exception ex) {
			showOkDialogError(ex);
		}
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	private View.OnClickListener ButtonClickListner = new View.OnClickListener() {		
		@Override
		public void onClick(View view) {
			Intent intent = null;
			
//			Cursor cursor = null;
			
			try {
				switch (view.getId()) {
				case R.id.imageViewButtonSave:
					// 항목 값의 유효성을 검사한다.
					if (_EditTextId.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextId.requestFocus();
						
						return;
					}
					else if (_EditTextName.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextName.requestFocus();
						
						return;
					}
					else if (_EditTextAge.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextAge.requestFocus();
						
						return;
					}
					else if (_SpinnerSex.getCount() < 0) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_SpinnerSex.requestFocus();
						
						return;
					}	
					else if (_EditTextHeight.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextHeight.requestFocus();
						
						return;
					}
					else if (_EditTextWeigh.getText().toString().equals("")) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_EditTextWeigh.requestFocus();
						
						return;
					}
					else if (_SpinnerHospital.getCount() < 0) {						
						showOkDialog(getString(R.string.shortmessage_Check), getString(R.string.message_Please_input_data), null);
						
						_SpinnerHospital.requestFocus();
						
						return;
					}	
					else {
						//
					}
					
					// 환자 기본정보를 수정한다.
					modifyPatientInformation();
					
					// 정상 수정메시지를 보여준다.
					Toast.makeText(copa0300a.this,  getString(R.string.message_Corrected_successfully), Toast.LENGTH_SHORT).show();
					
					break;
//				case R.id.imageViewCancel:
//					finish();
//					
//					break;
				}
				
			}
			catch (Exception ex) {
				showOkDialogError(ex);
			}
		}
	};	
	
/* region 메서드이다. *****************************************************************************************************/
    
	/**
	 * 초기화한다.
	 */
    private void initialize() {
//    	Cursor cursor = null;
    	
		try {
			// 성별 목록을 바인딩한다.						
			bindSexList();
	        
			// 의료기관 목록을 바인딩한다.						
			bindHospitalList();
 	    	
			// 환자 기본정보를 바인딩한다.
			bindPatientInformation();
			
			// 아이디와 의료기관 항목을 비활성화한다.
			_EditTextId.setEnabled(false);
			_SpinnerHospital.setEnabled(false);
		}
		finally {
//			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 성별 목록을 바인딩한다.
	 */
    private void bindSexList() {
    	Cursor cursor = null;
    	
		try {
			// 목록을 가져온다.							
			cursor = getSexList();
	    				
			// 목록을 바인딩한다.	
			ArrayList<CharSequence> genderListItems = new ArrayList<CharSequence>();
			
			_SexListItems = new ArrayList<ListItem>();
			
			while (cursor.moveToNext()) {
				String Code = cursor.getString(0);
				String name = cursor.getString(1);
				
				genderListItems.add(name);
				
				_SexListItems.add(new ListItem(-1, Code, name));
			}
			
//	        _ArrayAdapter = ArrayAdapter.createFromResource(this, android.R.layout.simple_spinner_item); 
			_SexArrayAdapter = new ArrayAdapter(this, android.R.layout.simple_spinner_item, genderListItems);  
			_SexArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	        
	        _SpinnerSex.setAdapter(_SexArrayAdapter);
	        
	        _SpinnerSex.setSelection(0);
	        
//	        _SpinnerGender.setOnItemSelectedListener(SpinnerItemSelectedListener);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 의료기관 목록을 바인딩한다..
	 */
    private void bindHospitalList() {
    	Cursor cursor = null;
    	
		try {
			// 목록을 가져온다.						
 			cursor = getHospitalList();
 	    				
 			// 목록을 바인딩한다.	
 			ArrayList<CharSequence> hospitalListItems = new ArrayList<CharSequence>();
 			
 			_HospitalListItems = new ArrayList<ListItem>();
 			
 			while (cursor.moveToNext()) {
 				String Code = cursor.getString(0);
 				String name = cursor.getString(1);
 				
 				hospitalListItems.add(name);
 				
 				_HospitalListItems.add(new ListItem(-1, Code, name));
 			}
 			
 			_HospitalArrayAdapter = new ArrayAdapter(this, android.R.layout.simple_spinner_item, hospitalListItems);  
 			_HospitalArrayAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
 	        
 	        _SpinnerHospital.setAdapter(_HospitalArrayAdapter);
 	        
// 	       _SpinnerHospital.setOnItemSelectedListener(SpinnerItemSelectedListener);
 	        
 	       _SpinnerHospital.setSelection(0);
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 환자 기본정보를 바인딩한다.
	 */
    private void bindPatientInformation() {
    	Cursor cursor = null;
    	
		try {
	        // 데이터를 가져온다.						
 			cursor = getPatientInformation();
 	    	
 			// 데이터를 바인딩한다.
 			while (cursor.moveToNext()) {	 			
				_EditTextId.setText(cursor.getString(0));
	        	_EditTextName.setText(cursor.getString(1));
	        	_EditTextAge.setText(cursor.getString(2));
	        	_SpinnerSex.setSelection(ListUtil.getInstance().getItemIndex(_SexListItems, cursor.getString(3)));
	        	_EditTextHeight.setText(cursor.getString(4));
	        	_EditTextWeigh.setText(cursor.getString(5));
	        	_EditTextDiagnosis.setText(cursor.getString(6));
	        	_SpinnerHospital.setSelection(ListUtil.getInstance().getItemIndex(_HospitalListItems, cursor.getString(7)));
 			}
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
    }
    
    /**
	 * 성별 목록을 가져온다.
	 */
    private Cursor getSexList() {
    	SQLiteDatabase db = null;
    	
		try {
			// 목록을 조회한다.
			String sql = "SELECT Code," 			+
			                    "Name " 			+
			             "FROM TbCommonCode "		+
			             "WHERE CategCd = '01'";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 의료기관 목록을 가져온다.
	 */
    private Cursor getHospitalList() {
    	SQLiteDatabase db = null;
    	
		try {
			// 목록을 조회한다.
			String sql = "SELECT Code," 				+
					                    "Name " 			+
				             "FROM TbHospital "		+
				             "WHERE UseYn = 1";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 환자 기본정보를 가져온다.
	 */
    private Cursor getPatientInformation() {
    	SQLiteDatabase db = null;
    	
		try {
	    	// 데이터를 조회한다.
			String sql = "SELECT Id," 							+
			    	                    "Name," 					+
			    	                    "Age," 						+
			    	                    "Gender," 					+
			    	                    "Height," 					+
			    	                    "Weigh," 					+
			    	                    "Diagnosis," 				+
			    	                    "HospitalCd " 				+
				             "FROM TbPatient "					+
				             "WHERE No = " + _PatientNo;
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
    
    /**
	 * 환자 기본정보를 수정한다.
	 */
    private void modifyPatientInformation() {
    	SQLiteDatabase db = null;
		
		try {
			// 데이터를 수정한다.
			String sql = "UPDATE TbPatient SET Id = '" + _EditTextId.getText() + "'," 																					+
									                   "Name = '" + _EditTextName.getText() + "'," 																				+
									                   "Age = '" + _EditTextAge.getText() + "'," 																					+
									                   "Gender = '" + _SexListItems.get((int)_SpinnerSex.getSelectedItemId()).getCode() + "'," 			+
									                   "Height = '" + _EditTextHeight.getText() + "'," 																			+
									                   "Weigh = '" + _EditTextWeigh.getText() + "'," 																			+
									                   "Diagnosis = '" + _EditTextDiagnosis.getText() + "'," 																	+
									                   "HospitalCd = '" + _HospitalListItems.get((int)_SpinnerHospital.getSelectedItemId()).getCode() + "' " 	+
				             "WHERE NO = " + _PatientNo;
			
			db = _DbOpenHelper.getWritableDatabase();			
			db.execSQL(sql);
		}
		finally {
			if (db != null) db.close(); db = null;
		}
    }
}