package kr.nipa.smartui.phone.ui.cough.preference;

import java.util.ArrayList;

import kr.nipa.smartui.phone.R;

import kr.nipa.smartui.phone.framework.base.cough.PreferenceActivityBase;
import kr.nipa.smartui.phone.framework.db.cough.DbOpenHelper;
import kr.nipa.smartui.phone.ui.Application;
import android.content.Intent;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceClickListener;

public class copr0000a extends PreferenceActivityBase implements OnPreferenceClickListener {
	private Application _Application = null;
	private DbOpenHelper _DbOpenHelper = null;
	
	private Preference _PreferenceDateTime = null;
	private ListPreference _PreferenceHospitalCode = null;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        addPreferencesFromResource(R.layout.ui_copr0000a);
        
        try {
        	_Application = (Application)getApplication();
        	_DbOpenHelper = new DbOpenHelper(this);
        	
        	_PreferenceDateTime = findPreference("cough_preference_datetime");
        	_PreferenceHospitalCode = (ListPreference)findPreference("cough_preference_hospital_code");
	        
	        _PreferenceDateTime.setOnPreferenceClickListener(this);
        }
        catch (Exception ex) {
			showOkDialogError(ex);
		}
    }

	@Override
    public void onResume() {
		Cursor cursor = null;
		
		try {
			cursor = getHospitalList();
			
			ArrayList<String> codeList = new ArrayList<String>();
	 		ArrayList<String> nameList = new ArrayList<String>();
			while (cursor.moveToNext()) {
				codeList.add(cursor.getString(0));
				nameList.add(cursor.getString(1));
			}
			
			_PreferenceHospitalCode.setEntries(nameList.toArray(new String[nameList.size()]));
	        _PreferenceHospitalCode.setEntryValues(codeList.toArray(new String[codeList.size()]));
		}
		finally {
			if (cursor != null) cursor.close(); cursor = null;
		}
		
    	super.onResume();
    }
	
	@Override
	public void onPause() {
    	super.onPause();
    }
	
/* region 이벤트 핸들러이다. *****************************************************************************************************/
	
	@Override
	public boolean onPreferenceClick(Preference preference) {
		Intent intent = null;
		
		try {			
			if (preference.getKey().equals("cough_preference_datetime")) {				
				intent = new Intent(android.provider.Settings.ACTION_DATE_SETTINGS);
				startActivity(intent);
			}			
		}
		catch (Exception ex) {
			showOkDialogError(ex);
		}
		
		return true;
	}
	
	/**
	 * 의료기관 목록을 가져온다.
	 */
	private Cursor getHospitalList() {
    	SQLiteDatabase db = null;
    	
		try {
			// 목록을 조회한다.
			String sql = "SELECT Code," 					+
								"Name " 					+
			             "FROM TbHospital "					+
			             "WHERE UseYn = 1";
			
			db = _DbOpenHelper.getReadableDatabase();			
			return db.rawQuery(sql, null);
		}
		finally {
//			if (db != null) db.close(); db = null;
		}
    }
}